<!DOCTYPE html>
<html lang="en" xmlns="http://www.w3.org/1999/xhtml" xmlns:th="http://www.thymeleaf.org">
<head>
    <meta charset="UTF-8">
    <title>Open Banking Brasil Functional Conformance: Processing Implicit Callback</title>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">

    <!-- Boostrap Icons -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.3/font/bootstrap-icons.css">

    <!-- Optional theme -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=PT+Sans">
    <link rel="stylesheet" type="text/css" href="/css/layout.css">



</head>
<body>
    <div class="pageHeader container-fluid">
        <div class="row">
            <div class="col-md-8">
                <a href="index.html"><img id="logo" src=''></a>
            </div>
        </div>
    </div>
    <div class="clearfix"></div>

    <div class="container-fluid">
        <div class="row">
            <div class="col-xs-12 col-md-6 col-md-offset-3 mx-auto center-text">
                <h1 class="text-center">Please wait...</h1>
                <h2 class="text-center">Processing response from authorization server<sup><span class="bi bi-question-circle-fill" data-bs-toggle="tooltip" title="The server should have returned its results as part of a URI fragment. This data normally stays in the browser and needs to be explicitly sent to the test framework for further processing." data-bs-placement="right"></span></sup></h2>
                <p id="complete" class="bg-info collapse">The response has been sent to the server for processing. You may return to <a href="" class="link-primary">the test results page.</a></p>
            </div>
        </div>
    </div>
    <!-- Include all compiled plugins (below), or include individual files as needed -->
    <!-- Popper (necessary for Bootstrap's tooltips) -->
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.11.6/dist/umd/popper.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.min.js" integrity="sha384-cuYeSxntonz0PPNlHhBs68uyIAVpIIOZZ5JqeqvYYIcEL727kskC66kF92t6Xl2V" crossorigin="anonymous"></script>

    <footer class="pageFooter">
        <div class="row">
            <span class="muted"><div class="brandDesc"></div><br /></span>
            <span class="muted"></span><a href="https://raidiam.com"><img src="/images/raidiam.png" width="285" height="32" alt="Raidiam"></a></span>
            <div class="serverInfo"></div>
        </div>
    </footer>

    <script type="text/javascript" th:inline="javascript">
        var submitComplete = false;
        function assumeComplete() {
            if (submitComplete) {
                return;
            }
            console.log("assumeComplete workaround for https://gitlab.com/openid/conformance-suite/-/issues/766 activated - assuming post has completed as 5 seconds have elapsed")
            // add a hidden tag so that Selenium can detect we're done processing

            document.getElementById('complete').insertAdjacentHTML('beforeend', '<span id="submission_complete" hidden></span>');
        }

        document.addEventListener("DOMContentLoaded", () => {

            var hash = window.location.hash;

            var returnUrl = [[${returnUrl}]];

            // workaround https://gitlab.com/openid/conformance-suite/-/issues/766 by assuming that the post completes
            // after 5 seconds
            setTimeout(function(){ assumeComplete(); }, 5000);

            var xhr = new XMLHttpRequest();
            xhr.open('POST', [[${implicitSubmitUrl}]], true);
            xhr.setRequestHeader('Content-type', 'text/plain');
            xhr.onload = function () {
                console.log("implicit submit complete")
                document.querySelector('#complete a').setAttribute("href", returnUrl);
                document.getElementById('complete').classList.add('show');
                submitComplete = true;
                // add a hidden tag so that Selenium can detect we're done processing
                document.getElementById('complete').insertAdjacentHTML('beforeend', '<span id="submission_complete" hidden></span>');
            };
            xhr.send(hash);
        });

        document.addEventListener('DOMContentLoaded', () => {
            loadServerInfo();
        });


        function loadServerInfo() {
            return fetch('/api/server')
                .then((response) => response.json())
                .then((data) => {
                    const brandDesc = document.querySelector('.brandDesc');
                    brandDesc.textContent = `${data.brand} Functional Conformance Suite - Brought to you by Raidiam, with thanks to the OpenID Foundation`;

                    const logo = document.querySelector('#logo');
                    logo.src = `/images/${data.logo}`;
                    serverInfoObject = data;
                });
        }
    </script>


</body>
</html>
